#!/usr/bin/env python
#-*-coding:utf-8 -*-
import pymysql
import pandas as pd
import matplotlib.pyplot as plt
#任务1：查询某个用户是否有处于OVERDUE状态的进件
# Connect to the database
connection = pymysql.connect(host='localhost',
                             user='root',
                             password='root',
                             db='lesson14',
                             charset='utf8',
                             #cursorclass=pymysql.cursors.DictCursor
                             )
#1、根据给定金融借款数据，分析出在已知借款人中，男女的具体比例。根据查询结果，画出饼图进行展示
def get_sex_persent():
    try:
        rs = []
        sql_f = "SELECT  count(*) as person_count FROM `person` WHERE `sex`=%s"
        sex_f = 'FEMALE'
        sql_m = "SELECT  count(*) as person_count FROM `person` WHERE `sex`=%s"
        sex_m = 'MALE'
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql_f, (sex_f))
            r_f = cursor.fetchone()
            cursor.execute(sql_m, (sex_m))
            m_f = cursor.fetchone()
            rs = [r_f,m_f]
            return rs
    finally:
        connection.close()

# r = get_sex_persent()
# female_percent = format( r[1][0] /(r[1][0]+r[1][0])*100,'0.2f')#女性占比数
# male_percent = format(r[1][0] /( r[1][0]+r[1][0])*100,'0.2f')#男性占比数
# plt.rcParams['font.sans-serif'] = ['SimHei']  # 用来正常显示中文标签
# labels = ['FEMALE', 'MALE']
# sizes = [female_percent, male_percent]
# explode = (0, 0)
# plt.pie(sizes, explode=explode, labels=labels, autopct='%1.1f%%', shadow=False, startangle=100)
# plt.title("饼图示例-男女比例")
# plt.show()




#2、查询各种状态进件所占百分比，画出饼图进行展示
def get_status_persent():
    try:
        sql_status = "SELECT  status  FROM `apply` group by status"#按状态进行分组，有哪些状态
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql_status)
            rs = cursor.fetchall()
            r = []
            dict_all = {}#定义字典 放入各个状态对应的数据
            for status in rs:
              sql = "SELECT  count(*) as status_count FROM `apply` WHERE `status`=%s"
              cursor.execute(sql,(status[0]))
              f = cursor.fetchone()[0]
              dict = {status[0]:f}
              dict_all.update(dict)
            r.append(dict_all)
        return r
    finally:
        connection.close()

# r = get_status_persent()
# sum = 0
# lable = []
# size = []
# sizes = []
# for v in r:
#     for dk,dv in v.items():
#          sum +=dv#计算状态值的总和
#          lable.append(dk)#状态名称
#          size.append(dv)#每个状态 的值放到一个数据里面
#
# for n in size:#计算每个状态占用的比例
#     sizes.append(round(n / sum * 100, 2))
#
# plt.rcParams['font.sans-serif'] = ['SimHei']  # 用来正常显示中文标签
# labels = lable
# explode = (0, 0,0,0)
# plt.pie(sizes, explode=explode, labels=labels, autopct='%1.1f%%', shadow=False, startangle=100)
# plt.title("饼图示例-男女比例")
# plt.show()



#　任务2
# 3根据进件状态，分析出男人逾期的概率大还是女人逾期的概率大
# TODO：查询一共有多少女性及男性用户
male_count = 0
female_count = 0
# 计算male_count与female_count值
def get_sex_status():
    try:
        rs = []
        sql_f = "SELECT  count(*) as person_count FROM `person` WHERE `sex`=%s"
        female = 'FEMALE'
        sql_m = "SELECT  count(*) as person_count FROM `person` WHERE `sex`=%s"
        male = 'MALE'
        status = 'OVERDUE'
        sql_stat = "SELECT  count(*) as female_stat_count FROM `person` as `p`  INNER JOIN `apply` as `a`  on p.id = a.applicant   WHERE `p`.`sex`=%s and a.status= %s"
        #sql_m_stat = "SELECT  count(*) as female_stat_count FROM `person` as p  INNER join `apply` as a  on p.id = a.applicant   WHERE `p.sex`=%s and a.status= %s"
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql_f, (female))
            r_female = cursor.fetchone()#女性用户
            cursor.execute(sql_m, (male))
            m_male = cursor.fetchone()#男性用户
            cursor.execute(sql_stat, (female,status))
            f_stat_count = cursor.fetchone()#逾期女性
            cursor.execute(sql_stat, (male,status))
            m_stat_count = cursor.fetchone()#逾期男性
            rs = [r_female, m_male,f_stat_count,m_stat_count]
            return rs
    finally:
        connection.close()
r = get_sex_status()
female_count = r[0][0]
male_count = r[1][0]
overdue_female_count = r[2][0]
print('有%d名男性用户'%r[1][0])
print('有%d名女性用户'%r[0][0])
# 通过pandas读取数据库，计算逾期女性用户数量
print('有%d名逾期女性用户'%overdue_female_count)
# 通过pandas读取数据库，计算逾期男性用户数量
overdue_male_count = r[3][0]
print('有%d名逾期男性用户'%overdue_male_count)

# 根据以上结果，分析出男人逾期的概率大还是女人逾期的概率大。
pro_male = overdue_male_count / male_count
pro_female = overdue_female_count / female_count
print('男人逾期概率为:%f'%pro_male)
print('男人逾期概率为:%f'%pro_female)