#!/usr/bin/env python
#-*-coding:utf-8 -*-
import pymysql
import pandas as pd
import matplotlib.pyplot as plt
#任务1：查询某个用户是否有处于OVERDUE状态的进件
# Connect to the database
connection = pymysql.connect(host='localhost',
                             user='root',
                             password='root',
                             db='lesson14',
                             charset='utf8',
                             #cursorclass=pymysql.cursors.DictCursor
                             )
#1、查询各进件金额的大致分布
def get_status_amount():
    try:
        sql = "SELECT  sum(amount)as amount,status  FROM `apply` group by status"
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql,)
            r = cursor.fetchall()
            return r
    finally:
        connection.close()
# r = get_status_amount()
# print(r)

#2 、查询所有进件已偿还的总额度(代码及sql两种实现方式）
def get_repaid_amount(status):
    try:
        sql = "SELECT  sum(amount) as amount FROM `apply` where status =%s"
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql, (status))
            r = cursor.fetchone()
            return r
    finally:
        connection.close()
#r = get_repaid_amount('REPAID')


# 3、查询手机号为xxx的用户的所有进件
def get_apply_detail(phone):
        try:
            sql = "SELECT  a.* FROM `person` as `p`  INNER JOIN `apply` as `a`  on p.id = a.applicant   WHERE `p`.`phone`=%s"
            with connection.cursor() as cursor:
                # Read a single record
                cursor.execute(sql,(phone))
                r = cursor.fetchall()
                return r
        finally:
            connection.close()

#r = get_apply_detail(1342416782)
#print(r)

#4 找出所有申请中状态(IN_PROGRESS)的进件，按金额重大到小排序
def get_in_progress(status):
    try:
        sql = "SELECT  a.* FROM  `apply` as `a` where `a`.`status`=%s  order  by a.amount desc"
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql, (status))
            r = cursor.fetchall()
            return r
    finally:
        connection.close()
#r = get_in_progress('IN_PROGREESS')
#print(r)

# 5 查询所有拥有申请中状态(IN_PROGRESS)的进件的男性用户的姓名与申请金额，按金额重大到小排序
def get_female_amount(status,sex):
    try:
        sql = "SELECT  p.id,p.name,a.amount FROM `person` as `p`  INNER JOIN `apply` as `a`  on p.id = a.applicant   WHERE `p`.`sex`=%s and a.status= %s order  by  a.amount desc "
        with connection.cursor() as cursor:
            # Read a single record
            cursor.execute(sql, (sex,status))
            r = cursor.fetchall()
            return r
    finally:
        connection.close()
#r = get_female_amount('IN_PROGREESS','MALE')
#print(r)
# 6、绘制某个号码联系过的所有人的性别的分布情况

def get_sex_distribution(phone):
    # 通过sql语句查询phone的联系人的sex值
    sql = "SELECT  p.sex,count(*)as cnt FROM `call` as `c`  LEFT JOIN `person` as `p` on c.to = p.phone   WHERE `c`.`from`=%s  and p.sex is not null group  by  p.sex"
    with connection.cursor() as cursor:
        cursor.execute(sql,(phone))
        r = cursor.fetchall()
    # 保存sex一列的值，以list形式返回
    return r

# 校验
# sd = get_sex_distribution(1412429664)
# size =[]
# label=[]
# for v,k in sd:
#     size.append(k)
#     label.append((v))
# plt.pie(size,labels=label,autopct = '%3.1f%%')
# plt.axis('equal')
# plt.show()


# 7 绘制单人申请进件数量的分布圆饼图
def get_person_applicant(applicant):
    # 通过sql语句查询phone的联系人的sex值
    sql = "SELECT status,count(*)as cnt FROM `apply`  WHERE `applicant`=%s group  by status "
    with connection.cursor() as cursor:
        cursor.execute(sql,(applicant))
        r = cursor.fetchall()
    # 保存sex一列的值，以list形式返回
    return r
#r = get_person_applicant(20000001)
r = get_person_applicant(20000002)
l = len(r)
sum = 0
lable = []
size = []
sizes = []
str =[]
for vl in r:
    sum += vl[1]
    lable.append(vl[0])
    size.append(vl[1])
    str.append(0)
for n in size:#计算每个状态占用的比例
    sizes.append(format(n / (sum) * 100, '0.2f'))

plt.rcParams['font.sans-serif'] = ['SimHei']  # 用来正常显示中文标签
labels = lable
explode = (str)
plt.pie(sizes, explode=explode, labels=labels, autopct='%1.1f%%', shadow=False, startangle=100)
plt.title("饼图示例-单人申请进件数量比例")
plt.show()